/*
 Author: Tonetta Ivan (Ruben) - 2016.02 - Italy
- many thanks to God [Yahwéh, YHWH, Geova]: He made life possible, and all you can do with it;
- many thanks to my wife and my children for their patience;
- many thanks to Rory Walsh for Cabbage and his great support (http://forum.cabbageaudio.com/);
- many thanks to Iain McCurdy, for his support and all code shared (http://iainmccurdy.org/);
- many thanks to Riccardo Bianchini, Alessandro Cipriani, Giorgio Zucco, Jim Aikin for their wonderful books and "Vallste" for his (old) support (http://triceratupuz.altervista.org/";
- many thanks to Barry Vercoe and all Csound developers in the world (http://www.csounds.com/);

I'm not a writer of professional code in csound; so what I present is a very simple 3 oscillators (saw, sq, tri) for subtractive technique: 18dBOct with Distortion unit, Ring mod mixed on Osc 1 with 4 differents waves
final waveshaping with audio limit Low/High and freeverb...

*/
<Cabbage>
form size(723, 316), caption("Cabbtractive1.1"), pluginID("plu1")

groupbox bounds(004,004,210,100), colour(160,160,160,020), text("Osc1"), plant("OSC"){
rslider  bounds( -5,020,070,070), channel("pitch1"),    range(  -24, 24,      0,   1,  1     ),   text("Pitch"),   textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(040,020,070,070), channel("fine1"),     range(   -1,  1,      0,   1,  .1    ),   text("Fine"),    textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(145,020,070,070), channel("amp1"),      range( .001,  1,     .8,  .5,  .01   ),   text("Vol"),     textbox(1), colour(255,000,000,050), trackercolour(255,000,000,255), fontcolour(255,000,000,255)
combobox bounds(100,050,055,020), channel("combobox1"), items("Saw", "Pulse", "Tri"), colour(155,000,000,255), fontcolour("black")
}
groupbox bounds(004,108,210,100), colour(160,160,160,020), text("Osc2"), plant("OSC"){
rslider  bounds( -5,020,070,070), channel("pitch2"),    range(  -24, 24,      0,   1,   1    ),   text("Pitch"),   textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(040,020,070,070), channel("fine2"),     range(   -1,  1,      0,   1,   .001 ),   text("Fine"),    textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(145,020,070,070), channel("amp2"),      range( .001,  1,     .8,  .5,   .01  ),   text("Vol"),     textbox(1), colour(255,000,000,050), trackercolour(255,000,000,255), fontcolour(255,000,000,255)
combobox bounds(100,050,055,020), channel("combobox2"), items("Saw", "Pulse", "Tri"), colour(155,000,000,255), fontcolour("black")
}
groupbox bounds(004,212,210,100), colour(160,160,160,020), text("Osc3"), plant("OSC"){
rslider  bounds( -5,020,070,070), channel("pitch3"),    range(  -24, 24,      0,   1,   1    ),   text("Pitch"),   textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(040,020,070,070), channel("fine3"),     range(   -1,  1,      0,   1,   .001 ),   text("Fine"),    textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(145,020,070,070), channel("amp3"),      range( .001,  1,     .8,  .5,   .01  ),   text("Vol"),     textbox(1), colour(255,000,000,050), trackercolour(255,000,000,255), fontcolour(255,000,000,255)
combobox bounds(100,050,055,020), channel("combobox3"), items("Saw", "Pulse", "Tri"), colour(155,000,000,255), fontcolour("black")
}
groupbox bounds(218,212,240,100), colour(160,160,160,020), text("Global Amp"), plant("AMP"){
rslider  bounds(000,020,070,070), channel("a1"),        range(.0001,  5,     .01, .5,   .01  ),   text("A"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(040,020,070,070), channel("d1"),        range(.0001,  5,     .01, .5,    .01 ),   text("D"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(080,020,070,070), channel("s1"),        range(.0001,  1,     1,   1,     .01 ),   text("S"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(120,020,070,070), channel("r1"),        range(.0001,  5,     .01, .5,    .01 ),   text("R"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(170,020,070,070), channel("master"),    range(.0001,  1,     .1,  .5,    .001),   text("Master"),  textbox(1), colour(255,000,000,050), trackercolour(255,000,000,255), fontcolour(255,000,000,255)
} 
groupbox bounds(218,004,240,205), colour(160,160,160,020), text("Filter"), plant("FILT"){
rslider  bounds(000,025,070,070), channel("cut"),       range(.001,   128,   80,   1,    1   ),   text("Cutoff"),  textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(040,025,070,070), channel("res"),       range(.001,   2,     .001, 1,    .001),   text("Reso"),    textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(080,025,070,070), channel("dist"),      range(.001,   1,     .180, 1,    .001),   text("Distort"), textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(000,125,070,070), channel("a2"),        range(.001,   5,     .01,  1,    .01 ),   text("A"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(040,125,070,070), channel("d2"),        range(.001,   5,     .01,  1,    .01 ),   text("D"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(080,125,070,070), channel("s2"),        range(.001,   1,     1,    1,    .01 ),   text("S"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(120,125,070,070), channel("r2"),        range(.001,   5,     .01,  1,    .01 ),   text("R"),       textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(170,125,070,070), channel("envamt"),    range(.001,   1,     .5,   1,    .01 ),   text("EnvAmt"),  textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
}
groupbox bounds(462,004,100,100), colour(160,160,160,020), text("Limit"), plant("WAVESHAPING"){
rslider  bounds( -8,025,070,070), channel("low"),       range(  -1,   .05,    -1,   1,    .001),   text("Low"),    textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(040,025,070,070), channel("high"),      range(-.05,   1,      1,    1,    .001),   text("High"),   textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
}
groupbox bounds(566,004,153,100), colour(160,160,160,020), text("Ring Mod"), plant("WAVESHAPING"){
rslider  bounds( -8,025,070,070), channel("rmamt"),     range(.001,   1,    .001,  1,    .001  ), text("Amt"),     textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(092,025,070,070), channel("rmfrq"),     range(.001,   80,   60,    1,    1     ), text("Note"),    textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
combobox bounds(050,050,055,020), channel("combobox4"), items("Saw", "Pulse", "Tri", "Sine"), value(4), colour(155,000,000,255), fontcolour("black")
}
groupbox bounds(462,108,258,102), colour(160,160,160,020), text("Reverb"), plant("EFFECT"){
button   bounds(025,050,025,020), channel("button3"),  text("Off", "On"), colour:0(155,000,000,255), colour:1(255,000,000,255), fontcolour:0(000,000,000,255), fontcolour:1(000,000,000,255)
rslider  bounds(060,025,070,070), channel("mix"),       range(.001,   1,    0,     1,    .001  ), text("Mix"),     textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(120,025,070,070), channel("room"),      range(.001,   1,    .5,    1,    .001  ), text("Room"),    textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
rslider  bounds(180,025,070,070), channel("dmph"),      range(.001,   1,    0,     1,    .001  ), text("Dmp"),     textbox(1), colour(155,000,000,050), trackercolour(155,000,000,255), fontcolour(155,000,000,255)
}
groupbox   bounds(462,214,258,027), linethickness(0), colour(160,160,160,020), plant("General"){ 
combobox   bounds(004,004,190,020), channel("combobox"), populate("*.snaps")
filebutton bounds(204,004,050,020), channel("save"), text("Save"), populate("*.snaps")
}
groupbox   bounds(462,245,258,027), linethickness(0), colour(160,160,160,020), plant("General"){ 
label      bounds(045,006,170,015), text("Tonetta Ivan - 2016.02"), align("left"), fontcolour("red")
}
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 --midi-velocity-amp=5 ; --midi-key-cps=4
</CsOptions>
<CsInstruments>
sr = 44100
ksmps = 16
nchnls = 2
0dbfs = 1

garev init 0 ; global variable for reverb

instr 1
; receiving GUI values
kpitch1    chnget "pitch1"
kfine1     chnget "fine1"
icombobox1 chnget "combobox1"
kpitch2    chnget "pitch2"
kfine2     chnget "fine2"
icombobox2 chnget "combobox2"
kpitch3    chnget "pitch3"
kfine3     chnget "fine3"
icombobox3 chnget "combobox3"
ia1        chnget "a1"
id1        chnget "d1"
is1        chnget "s1"
ir1        chnget "r1"
kamp1      chnget "amp1"
kamp2      chnget "amp2"
kamp3      chnget "amp3"
ia2        chnget "a2"
id2        chnget "d2"
is2        chnget "s2"
ir2        chnget "r2"
kcut       chnget "cut"
kres       chnget "res"
kenvamt    chnget "envamt"
kdist      chnget "dist"
klow       chnget "low"
khigh      chnget "high"
krmamt     chnget "rmamt"
krmfrq     chnget "rmfrq"
icombobox4 chnget "combobox4"
ibutton3   chnget "button3"
kmaster    chnget "master"
; Smooth k values
kcut     portk kcut,     .01
kres     portk kres,     .01
kdist    portk kdist,    .01
kenvamt  portk kenvamt,  .01
kmaster  portk kmaster,  .01
klow     portk klow,     .01
khigh    portk khigh,    .01
krmamt   portk krmamt,   .01
krmfrq   portk krmfrq,   .01
; Midi Note NUMBER at input
imidi notnum
; Pitch-Bender in cps values (with 2+ and 2- octaves range)
kpb pchbend 0, 24
; Conversion: MIDI note number, Pitch + Fine GUI values and bend value to cps (because oscili request cps, not MIDI, values)
kcps1 cpsmidinn imidi+kpitch1+kfine1+kpb
kcps2 cpsmidinn imidi+kpitch2+kfine2+kpb
kcps3 cpsmidinn imidi+kpitch3+kfine3+kpb
; Amplitude envelope generation
kenv1 madsr ia1, id1, is1, ir1, 0, 1
; WaveShaping: Ring-Mod
krmfrq  cpsmidinn krmfrq
arm oscili krmamt, krmfrq+kcps1, icombobox4
; Audio generation: the amplitude is controlled with envelope and "Vol" knob present on GUI at each oscillator
a1 oscili (kenv1 * kamp1) + arm, kcps1, icombobox1
a2 oscili (kenv1 * kamp2), kcps2, icombobox2
a3 oscili (kenv1 * kamp3), kcps3, icombobox3
; General amplitude correction (prevent distortion)
asig = (a1 + a2 + a3) * .333333
; Filter envelope
kenv2 madsr ia2, id2, is2, ir2, 0, 1
; Filter Envelope adapted to full range filter cutoff controlled with Amount knob; at this unique value, I add the value of Cutoff knob: total 128+128 = 256...
kenv2 = ((kenv2 * 128) * kenvamt) + kcut
; LIMITING the cutoff value at 128:
klimitcut limit kenv2, 0, 127
; Conversion MIDI values to CPS values (request by lpf18 cutoff input port)
kenv2 cpsmidinn klimitcut
; Filter
alp lpf18 asig, kenv2, kres, kdist

; WaveShaping: Limit
alim  limit  alp, klow, khigh
; If button is pushed, send the signal also to reverb
if      (ibutton3 == 1) then
	{
		garev = garev + alim
	}
else
	{
		garev init 0
	}
endif
; Audio out with GUI gain control
outs alim * kmaster, alim * kmaster
endin

instr 99
; receiving GUI values
kroom chnget "room"
kdmph chnget "dmph"
kmix  chnget "mix"
; Smooth k values
kroom portk kroom,    .01
kdmph portk kdmph,    .01
; Reverb
arL, arR  freeverb garev, garev, kroom, kdmph, sr, 0
; Audio out with GUI gain control
outs arL * kmix, arR * kmix
; reset global variable
garev = 0 
endin
</CsInstruments>  
<CsScore>
f 1 0  4096  7 1 4096  -1 ; Saw-Down
f 2 0  4096  7 1 2048 1 0 -1 2048 -1 ; Square
f 3 0 65536 7 -1 32768 1 32768 -1 ; Triangle
f 4 0 65536 10 1 ; Sine


f0 3600
i 99 0 3600 ; turn on efx instrument
</CsScore>
</CsoundSynthesizer>